using System.Text;
using JacobTechEncryption.Enums;
using LuskiServer.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Channels
{
    public static TableColumn<long> ID { get; } = new("id", true);
    public static TableColumn<long> Parent { get; } = new("parent") { DefaultValue = -1 };
    public static TableColumn<string> Color { get; } = new("color") {DefaultValue = "ÿÿÿÿ" };
    public static TableColumn<ChannelType> Type { get; } = new("type");
    public static TableColumn<DateTime> Epoch { get; } = new("epoch");
    public static TableColumn<byte[]> Name { get; } = new("name") { DefaultValue = Encoding.UTF8.GetBytes("New Channel") };
    public static TableColumn<byte[]> Description { get; } = new("description") { DefaultValue = Encoding.UTF8.GetBytes("New Channel") };
    public static TableColumn<long[]> RoleOverides { get; } = new("role_overides") { DefaultValue = Array.Empty<long>() };
    public static TableColumn<long[]> UserOverides { get; } = new("member_overides") { DefaultValue = Array.Empty<long>() };
    public static TableColumn<long> TitleEncryptionKey { get; } = new("title_encryption_key") { DefaultValue = 0 };
    public static TableColumn<long> DescriptionEncryptionKey { get; } = new("description_encryption_key") { DefaultValue = 0 };
    public static TableColumn<long[]> EncryptionKeys { get; } = new("encryption_keys") { DefaultValue = new long[]{0} };
    public static TableColumn<EncoderType> TitleEncoderType { get; } = new("title_encoder_type") { DefaultValue = EncoderType.UTF8 };
    public static TableColumn<EncoderType> DescriptionEncoderType { get; } = new("description_encoder_type") { DefaultValue = EncoderType.UTF8 };
    public static TableColumn<PictureType> PictureType { get; } = new("picture_type") {DefaultValue = Enums.PictureType.png };
    public static TableColumn<byte[]> Picture { get; } = new("picture");
    public static TableColumn<EncoderType[]> EncoderTypes { get; } = new("encoder_types") { DefaultValue = new [] 
    { 
        EncoderType.UTF8, EncoderType.UTF16, 
        EncoderType.UTF32, EncoderType.ASCII,
        EncoderType.Latin1, EncoderType.BigEndianUnicode 
    } };
}

[TableRow(typeof(Channels))]
public partial class ChannelRow
{}