using LuskiServer.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public class Users
{
    public static TableColumn<long> ID { get; } = new("id", true);
    public static TableColumn<string> DisplayName { get; } = new("displayname");
    public static TableColumn<long> SelectedChannel { get; } = new("selected_channel");
    public static TableColumn<Status> Status { get; } = new("status") { DefaultValue = Enums.Status.Offline };
    public static TableColumn<PictureType> PictureType { get; } = new("picture_type") {DefaultValue = Enums.PictureType.png };
    public static TableColumn<byte[]> Picture { get; } = new("picture");
    public static TableColumn<long[]> Roles { get; } = new("roles");
    public static TableColumn<byte[]> Username { get; } = new("username");
    public static TableColumn<byte[]> Password { get; } = new("password");
    public static TableColumn<byte[]> Salt { get; } = new("salt");
}

[TableRow(typeof(Users))]
public partial class UserRow
{}