using Asp.Versioning;
using LuskiServer.Classes;
using LuskiServer.Classes.TableDef;
using LuskiServer.Classes.WebTypes;
using LuskiServer.Enums;
using Microsoft.AspNetCore.Mvc;

namespace LuskiServer.Controllers.v1;

[ApiVersion(1)]
[ApiController]
public class SocketRoleController : ControllerBase
{
    [HttpGet]
    [Route(Luski.Info.Routes.Default.Base)]
    public IActionResult Get([FromQuery(Name = "id")]long id)
    {
        if (!this.CanTokenRequest(out long ID, out long SID, out IActionResult? toc) && toc != null) return toc;
        if (!Tables.Roles.TryReadRow(out RoleRow row, Roles.ID.CreateParameter(id))) return this.ShowError(ErrorCode.Forbidden, "User does not exist");
        return this.ResponseToResult(new Role()
        {
            id = row.ID,
            server_permissions = row.ServerPermissions,
            description = row.Description,
            display_name = row.DisplayName,
            index = row.Index,
            name = row.Name,
            members_list = row.MembersList,
            color = row.Color
        });
    }
}