using Asp.Versioning;
using JacobTechEncryption;
using LuskiServer.Classes;
using LuskiServer.Classes.TableDef;
using LuskiServer.Classes.v1.OutGoing;
using LuskiServer.Enums;
using Microsoft.AspNetCore.Mvc;

namespace LuskiServer.Controllers.v1;

[ApiVersion(1)]
[ApiController]
public class SocketUserController : ControllerBase
{
    [HttpGet]
    [Route(Luski.Info.Routes.Default.Base)]
    public IActionResult Get([FromHeader(Name = "id")]long Person)
    {
        try
        {
            if (!this.CanTokenRequest(out long ID, out long SID, out IActionResult? toc) && toc != null) return toc;
            if (Person != ID && !Tables.Users.TryRead(Users.ID, out _, Users.ID.CreateParameter(Person))) return this.ShowError(ErrorCode.Forbidden, "User does not exist");
            return this.ResponseToResult(new UserResponse()
            {
                id = Person,
                displayname = Tables.Users.Read(Users.DisplayName, Users.ID.CreateParameter(Person)),
                picture_type = Tables.Users.Read(Users.PictureType, Users.ID.CreateParameter(Person)),
                roles = Tables.Users.Read(Users.Roles, Users.ID.CreateParameter(Person)),
                status = Tables.Users.Read(Users.Status, Users.ID.CreateParameter(Person))
            });
        }
        catch (Exception e)
        {
            return this.ShowError(e);
        }
    }
}